﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace WinF
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            backgroundWorker1.RunWorkerAsync(null);
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            // Data buffer for incoming data.
            byte[] bytes = new byte[1024];

            // Connect to a remote device.
            try
            {
                // Establish the remote endpoint for the socket.
                // This example uses port 11000 on the local computer.
                IPEndPoint remoteEP = new IPEndPoint(System.Net.IPAddress.Parse("127.0.0.1"), 80);

                // Create a TCP/IP  socket.
                Socket socket = new Socket(AddressFamily.InterNetwork,
                    SocketType.Stream, ProtocolType.Tcp);

                // Connect the socket to the remote endpoint. Catch any errors.
                try
                {
                    socket.Connect(remoteEP);

                    textBox1.AppendText("Socket connected to " + socket.RemoteEndPoint.ToString());

                    // Encode the data string into a byte array.
                    byte[] msg = Encoding.ASCII.GetBytes("START<EOF>");

                    // Send the data through the socket.
                    int bytesSent = socket.Send(msg);
                    try
                    {
                        while (true)
                        {
                            // Receive the response from the remote device.
                            int bytesRec = socket.Receive(bytes);
                            textBox1.AppendText("\r\n" + Encoding.ASCII.GetString(bytes, 0, bytesRec));
                        }
                    }
                    catch (Exception socketException)
                    {
                        textBox1.AppendText("\r\n" + socketException.ToString());
                    }
                    finally
                    {
                        // Release the socket.
                        socket.Shutdown(SocketShutdown.Both);
                        socket.Close();
                    }

                }
                catch (ArgumentNullException ane)
                {
                    textBox1.AppendText("\r\nArgumentNullException : " + ane.ToString());
                }
                catch (SocketException se)
                {
                    textBox1.AppendText("\r\nSocketException : " + se.ToString());
                }
                catch (Exception genericClientException)
                {
                    textBox1.AppendText("\r\nUnexpected exception : " + genericClientException.ToString());
                }

            }
            catch (Exception connectionException)
            {
                textBox1.AppendText("\r\n" + connectionException.ToString());
            }
        }

    }
}
